commit 4183c04248fc92afaeaaf965345248f2e78e6e9c
Author: Renato Botelho <renato@netgate.com>
Date:   Mon Oct 2 13:52:02 2017 -0300

    Add new repos to lead users to 2.4.0 on amd64

diff --git a/tools/builder_common.sh b/tools/builder_common.sh
index 5da3ac5a28..35855b74a5 100644
--- a/tools/builder_common.sh
+++ b/tools/builder_common.sh
@@ -2476,12 +2476,18 @@ EOF
 
 	# Copy over pkg repo templates to pfSense-repo
 	mkdir -p /usr/local/poudriere/ports/${POUDRIERE_PORTS_NAME}/sysutils/${PRODUCT_NAME}-repo/files
-	cp -f ${PKG_REPO_BASE}/* \
-		/usr/local/poudriere/ports/${POUDRIERE_PORTS_NAME}/sysutils/${PRODUCT_NAME}-repo/files
 
 	for jail_arch in ${_archs}; do
 		jail_name=$(poudriere_jail_name ${jail_arch})
 
+		if [ "${jail_arch}" = "i386.i386" ]; then
+			cp -f ${PKG_REPO_BASE}_i386/* \
+				/usr/local/poudriere/ports/${POUDRIERE_PORTS_NAME}/sysutils/${PRODUCT_NAME}-repo/files
+		else
+			cp -f ${PKG_REPO_BASE}/* \
+				/usr/local/poudriere/ports/${POUDRIERE_PORTS_NAME}/sysutils/${PRODUCT_NAME}-repo/files
+		fi
+
 		if ! poudriere jail -i -j "${jail_name}" >/dev/null 2>&1; then
 			echo ">>> Poudriere jail ${jail_name} not found, skipping..." | tee -a ${LOGFILE}
 			continue
diff --git a/tools/templates/pkg_repos/pfSense-repo-devel.descr b/tools/templates/pkg_repos/pfSense-repo-devel.descr
index c2c9eb2fdb..8c214ec1f7 100644
--- a/tools/templates/pkg_repos/pfSense-repo-devel.descr
+++ b/tools/templates/pkg_repos/pfSense-repo-devel.descr
@@ -1 +1 @@
-Development Snapshots (Experimental)
+Development Snapshots (Experimental 2.3.x)
diff --git a/tools/templates/pkg_repos/pfSense-repo.abi b/tools/templates/pkg_repos/pfSense-repo.abi
new file mode 100644
index 0000000000..cd3225c707
--- /dev/null
+++ b/tools/templates/pkg_repos/pfSense-repo.abi
@@ -0,0 +1 @@
+FreeBSD:11:%%ARCH%%
diff --git a/tools/templates/pkg_repos/pfSense-repo.altabi b/tools/templates/pkg_repos/pfSense-repo.altabi
new file mode 100644
index 0000000000..ac860a1acf
--- /dev/null
+++ b/tools/templates/pkg_repos/pfSense-repo.altabi
@@ -0,0 +1 @@
+freebsd:11:%%ARCH%%
diff --git a/tools/templates/pkg_repos/pfSense-repo.conf b/tools/templates/pkg_repos/pfSense-repo.conf
index 6cde860d74..f501c86ed2 100644
--- a/tools/templates/pkg_repos/pfSense-repo.conf
+++ b/tools/templates/pkg_repos/pfSense-repo.conf
@@ -1,7 +1,7 @@
 FreeBSD: { enabled: no }
 
 %%PRODUCT_NAME%%-core: {
-  url: "%%PKG_REPO_SERVER_RELEASE%%/%%PRODUCT_NAME%%_%%PKG_REPO_BRANCH_RELEASE%%_%%ARCH%%-core",
+  url: "%%PKG_REPO_SERVER_RELEASE%%/%%PRODUCT_NAME%%_v2_4_0_%%ARCH%%-core",
   mirror_type: "srv",
   signature_type: "fingerprints",
   fingerprints: "/usr/local/share/%%PRODUCT_NAME%%/keys/pkg",
@@ -9,7 +9,7 @@ FreeBSD: { enabled: no }
 }
 
 %%PRODUCT_NAME%%: {
-  url: "%%PKG_REPO_SERVER_RELEASE%%/%%PRODUCT_NAME%%_%%PKG_REPO_BRANCH_RELEASE%%_%%ARCH%%-%%PRODUCT_NAME%%_%%PKG_REPO_BRANCH_RELEASE%%",
+  url: "%%PKG_REPO_SERVER_RELEASE%%/%%PRODUCT_NAME%%_v2_4_0_%%ARCH%%-%%PRODUCT_NAME%%_v2_4_0",
   mirror_type: "srv",
   signature_type: "fingerprints",
   fingerprints: "/usr/local/share/%%PRODUCT_NAME%%/keys/pkg",
diff --git a/tools/templates/pkg_repos_i386/pfSense-repo-devel.conf b/tools/templates/pkg_repos_i386/pfSense-repo-devel.conf
new file mode 100644
index 0000000000..dba6a6a1f2
--- /dev/null
+++ b/tools/templates/pkg_repos_i386/pfSense-repo-devel.conf
@@ -0,0 +1,17 @@
+FreeBSD: { enabled: no }
+
+%%PRODUCT_NAME%%-core: {
+  url: "%%PKG_REPO_SERVER_DEVEL%%/%%PRODUCT_NAME%%_%%PKG_REPO_BRANCH_DEVEL%%_%%ARCH%%-core",
+  mirror_type: "srv",
+  signature_type: "fingerprints",
+  fingerprints: "/usr/local/share/%%PRODUCT_NAME%%/keys/pkg",
+  enabled: yes
+}
+
+%%PRODUCT_NAME%%: {
+  url: "%%PKG_REPO_SERVER_DEVEL%%/%%PRODUCT_NAME%%_%%PKG_REPO_BRANCH_DEVEL%%_%%ARCH%%-%%PRODUCT_NAME%%_%%PKG_REPO_BRANCH_DEVEL%%",
+  mirror_type: "srv",
+  signature_type: "fingerprints",
+  fingerprints: "/usr/local/share/%%PRODUCT_NAME%%/keys/pkg",
+  enabled: yes
+}
diff --git a/tools/templates/pkg_repos_i386/pfSense-repo-devel.descr b/tools/templates/pkg_repos_i386/pfSense-repo-devel.descr
new file mode 100644
index 0000000000..8c214ec1f7
--- /dev/null
+++ b/tools/templates/pkg_repos_i386/pfSense-repo-devel.descr
@@ -0,0 +1 @@
+Development Snapshots (Experimental 2.3.x)
diff --git a/tools/templates/pkg_repos_i386/pfSense-repo.abi b/tools/templates/pkg_repos_i386/pfSense-repo.abi
new file mode 100644
index 0000000000..742d2af661
--- /dev/null
+++ b/tools/templates/pkg_repos_i386/pfSense-repo.abi
@@ -0,0 +1 @@
+FreeBSD:10:%%ARCH%%
diff --git a/tools/templates/pkg_repos_i386/pfSense-repo.altabi b/tools/templates/pkg_repos_i386/pfSense-repo.altabi
new file mode 100644
index 0000000000..e12ae76162
--- /dev/null
+++ b/tools/templates/pkg_repos_i386/pfSense-repo.altabi
@@ -0,0 +1 @@
+freebsd:10:%%ARCH%%
diff --git a/tools/templates/pkg_repos_i386/pfSense-repo.conf b/tools/templates/pkg_repos_i386/pfSense-repo.conf
new file mode 100644
index 0000000000..6cde860d74
--- /dev/null
+++ b/tools/templates/pkg_repos_i386/pfSense-repo.conf
@@ -0,0 +1,17 @@
+FreeBSD: { enabled: no }
+
+%%PRODUCT_NAME%%-core: {
+  url: "%%PKG_REPO_SERVER_RELEASE%%/%%PRODUCT_NAME%%_%%PKG_REPO_BRANCH_RELEASE%%_%%ARCH%%-core",
+  mirror_type: "srv",
+  signature_type: "fingerprints",
+  fingerprints: "/usr/local/share/%%PRODUCT_NAME%%/keys/pkg",
+  enabled: yes
+}
+
+%%PRODUCT_NAME%%: {
+  url: "%%PKG_REPO_SERVER_RELEASE%%/%%PRODUCT_NAME%%_%%PKG_REPO_BRANCH_RELEASE%%_%%ARCH%%-%%PRODUCT_NAME%%_%%PKG_REPO_BRANCH_RELEASE%%",
+  mirror_type: "srv",
+  signature_type: "fingerprints",
+  fingerprints: "/usr/local/share/%%PRODUCT_NAME%%/keys/pkg",
+  enabled: yes
+}
diff --git a/tools/templates/pkg_repos_i386/pfSense-repo.descr b/tools/templates/pkg_repos_i386/pfSense-repo.descr
new file mode 100644
index 0000000000..e892126ff6
--- /dev/null
+++ b/tools/templates/pkg_repos_i386/pfSense-repo.descr
@@ -0,0 +1 @@
+Stable (Default)