commit 5463dd9f779b83e691d13ee6f8e4d267bb39ff74
Author: me <me@me-laptop.(none)>
Date:   Wed Jun 23 23:33:14 2010 -0300

    gettext on archives firewall_aliases.php e firewall_nat.php

diff --git a/usr/local/www/firewall_aliases.php b/usr/local/www/firewall_aliases.php
index bc210a1b8a..28bb7e7ec5 100755
--- a/usr/local/www/firewall_aliases.php
+++ b/usr/local/www/firewall_aliases.php
@@ -147,7 +147,7 @@ if ($_GET['act'] == "del") {
 			}
 		}
 		if($is_alias_referenced == true) {
-			$savemsg = "Cannot delete rule.  Currently in use by {$referenced_by}";
+			$savemsg = gettext("Cannot delete rule.  Currently in use by {$referenced_by}");
 		} else {
 			unset($a_aliases[$_GET['id']]);
 			write_config();
@@ -169,7 +169,7 @@ include("head.inc");
 <form action="firewall_aliases.php" method="post">
 <?php if ($savemsg) print_info_box($savemsg); ?>
 <?php if (is_subsystem_dirty('aliases')): ?><p>
-<?php print_info_box_np("The alias list has been changed.<br>You must apply the changes in order for them to take effect.");?>
+<?php print_info_box_np gettext("The alias list has been changed.<br>You must apply the changes in order for them to take effect.");?>
 <?php endif; ?>
 
 <table width="100%" border="0" cellpadding="0" cellspacing="0">
@@ -230,7 +230,7 @@ include("head.inc");
           <a href="firewall_aliases_edit.php"><img src="/themes/<?= $g['theme']; ?>/images/icons/icon_plus.gif" width="17" height="17" border="0" title="add a new alias"></a></td>
         </td>
 	      <td valign="middle">
-           <a href="firewall_aliases_import.php"><img src="/themes/<?= $g['theme']; ?>/images/icons/icon_import_alias.gif" width="17" height="17" border="0" title="<?=gettext("Bulk import aliases from list");?>" alt="" /></a>
+           <a href="firewall_aliases_import.php"><img src="/themes/<?= $g['theme']; ?>/images/icons/icon_import_alias.gif" width="17" height="17" border="0" title="<?=gettext("Bulk import aliases from list");"?>" alt="" /></a>
         </td>
       </tr>
     </table>
@@ -238,7 +238,7 @@ include("head.inc");
 </tr>
 <tr>
   <td class="tabcont" colspan="3">
-   <p><span class="vexpl"><span class="red"><strong>Note:<br></strong></span>Aliases act as placeholders for real hosts, networks or ports. They can be used to minimize the number of changes that have to be made if a host, network or port changes. You can enter the name of an alias instead of the host, network or port in all fields that have a red background. The alias will be resolved according to the list above. If an alias cannot be resolved (e.g. because you deleted it), the corresponding element (e.g. filter/NAT/shaper rule) will be considered invalid and skipped.</span></p>
+   <p><span class="vexpl"><span class="red"><strong>Note:<br></strong></span>gettext("Aliases act as placeholders for real hosts, networks or ports.") gettext("They can be used to minimize the number of changes that have to be made if a host, network or port changes.") gettext("You can enter the name of an alias instead of the host, network or port in all fields that have a red background.") gettext("The alias will be resolved according to the list above.") gettext("If an alias cannot be resolved (e.g. because you deleted it), the corresponding element (e.g. filter/NAT/shaper rule) will be considered invalid and skipped.")</span></p>
   </td>
 </tr>
 </table>
diff --git a/usr/local/www/firewall_nat.php b/usr/local/www/firewall_nat.php
index 84fc0e8724..ccc524bf3f 100755
--- a/usr/local/www/firewall_nat.php
+++ b/usr/local/www/firewall_nat.php
@@ -158,7 +158,7 @@ if (isset($_POST['del_x'])) {
         }
 }
 
-$pgtitle = array("Firewall","NAT","Port Forward");
+$pgtitle = array(gettext("Firewall","NAT","Port Forward"));
 include("head.inc");
 
 echo "<script type=\"text/javascript\" language=\"javascript\" src=\"/javascript/domTT/domLib.js\"></script>";
@@ -174,18 +174,18 @@ echo "<script type=\"text/javascript\" language=\"javascript\" src=\"/javascript
 <?php if (is_subsystem_dirty('natconf')): ?><p>
 <?php
 	if($savemsg)
-		print_info_box_np("{$savemsg}<br>The NAT configuration has been changed.<br>You must apply the changes in order for them to take effect.");
+		print_info_box_np("{$savemsg}<br>gettext("The NAT configuration has been changed.")<br>gettext ("You must apply the changes in order for them to take effect.");
 	else
-		print_info_box_np("The NAT configuration has been changed.<br>You must apply the changes in order for them to take effect.");
+		print_info_box_np(gettext("The NAT configuration has been changed.<br>You must apply the changes in order for them to take effect."));
 ?>
 <?php endif; ?>
 <table width="100%" border="0" cellpadding="0" cellspacing="0">
   <tr><td>
 <?php
 	$tab_array = array();
-	$tab_array[] = array("Port Forward", true, "firewall_nat.php");
+	$tab_array[] = array(gettext("Port Forward"), true, "firewall_nat.php");
 	$tab_array[] = array("1:1", false, "firewall_nat_1to1.php");
-	$tab_array[] = array("Outbound", false, "firewall_nat_out.php");
+	$tab_array[] = array(gettext("Outbound"), false, "firewall_nat_out.php");
 	display_top_tabs($tab_array);
 ?>
  </td></tr>
@@ -210,7 +210,7 @@ echo "<script type=\"text/javascript\" language=\"javascript\" src=\"/javascript
                       <tr>
 			<td width="17">
 			<?php if (count($a_nat) == 0): ?>
-				<img src="./themes/<?= $g['theme']; ?>/images/icons/icon_x_d.gif" width="17" height="17" title="delete selected rules" border="0">
+				<img src="./themes/<?= $g['theme']; ?>/images/icons/icon_x_d.gif" width="17" height="17" title=gettext("delete selected rules") border="0">
 			<?php else: ?>
 				<input name="del" type="image" src="./themes/<?= $g['theme']; ?>/images/icons/icon_x.gif" width="17" height="17" title="delete selected rules" onclick="return confirm('Do you really want to delete the selected rules?')">
 			<?php endif; ?>
@@ -312,12 +312,12 @@ echo "<script type=\"text/javascript\" language=\"javascript\" src=\"/javascript
                   <td valign="middle" class="list" nowrap>
                     <table border="0" cellspacing="0" cellpadding="1">
                       <tr>
-                        <td><input onmouseover="fr_insline(<?=$nnats;?>, true)" onmouseout="fr_insline(<?=$nnats;?>, false)" name="move_<?=$i;?>" src="/themes/<?= $g['theme']; ?>/images/icons/icon_left.gif" title="move selected rules before this rule" height="17" type="image" width="17" border="0"></td>
+                        <td><input onmouseover="fr_insline(<?=$nnats;?>, true)" onmouseout="fr_insline(<?=$nnats;?>, false)" name="move_<?=$i;?>" src="/themes/<?= $g['theme']; ?>/images/icons/icon_left.gif" title=gettext("move selected rules before this rule") height="17" type="image" width="17" border="0"></td>
                         <td><a href="firewall_nat_edit.php?id=<?=$i;?>"><img src="/themes/<?= $g['theme']; ?>/images/icons/icon_e.gif" width="17" height="17" border="0" title="edit rule"></a></td>
                       </tr>
                       <tr>
-					    <td align="center" valign="middle"><a href="firewall_nat.php?act=del&id=<?=$i;?>"><img src="./themes/<?= $g['theme']; ?>/images/icons/icon_x.gif" width="17" height="17" border="0" title="delete rule" onclick="return confirm('Do you really want to delete this rule?')"></a></td>
-                        <td><a href="firewall_nat_edit.php?dup=<?=$i;?>"><img src="/themes/<?= $g['theme']; ?>/images/icons/icon_plus.gif" title="add a new nat based on this one" width="17" height="17" border="0"></a></td>
+					    <td align="center" valign="middle"><a href="firewall_nat.php?act=del&id=<?=$i;?>"><img src="./themes/<?= $g['theme']; ?>/images/icons/icon_x.gif" width="17" height="17" border="0" title=gettext("delete rule") onclick="return confirm(gettext('Do you really want to delete this rule?'))"></a></td>
+                        <td><a href="firewall_nat_edit.php?dup=<?=$i;?>"><img src="/themes/<?= $g['theme']; ?>/images/icons/icon_plus.gif" title=gettext("add a new nat based on this one") width="17" height="17" border="0"></a></td>
                       </tr>
                     </table>
 		</tr>
@@ -330,14 +330,14 @@ echo "<script type=\"text/javascript\" language=\"javascript\" src=\"/javascript
                   <td class="list" valign="middle" nowrap>
                     <table border="0" cellspacing="0" cellpadding="1">
                       <tr>
-                        <td><?php if ($nnats == 0): ?><img src="/themes/<?= $g['theme']; ?>/images/icons/icon_left_d.gif" width="17" height="17" title="move selected rules to end" border="0"><?php else: ?><input name="move_<?=$i;?>" type="image" src="/themes/<?= $g['theme']; ?>/images/icons/icon_left.gif" width="17" height="17" title="move selected rules to end" border="0"><?php endif; ?></td>
+                        <td><?php if ($nnats == 0): ?><img src="/themes/<?= $g['theme']; ?>/images/icons/icon_left_d.gif" width="17" height="17" title="move selected rules to end" border="0"><?php else: ?><input name="move_<?=$i;?>" type="image" src="/themes/<?= $g['theme']; ?>/images/icons/icon_left.gif" width="17" height="17" title=gettext("move selected rules to end") border="0"><?php endif; ?></td>
                       </tr>
                       <tr>
 			<td width="17">
 			<?php if (count($a_nat) == 0): ?>
-				<img src="./themes/<?= $g['theme']; ?>/images/icons/icon_x_d.gif" width="17" height="17" title="delete selected rules" border="0">
+				<img src="./themes/<?= $g['theme']; ?>/images/icons/icon_x_d.gif" width="17" height="17" title=gettext("delete selected rules") border="0">
 			<?php else: ?>
-				<input name="del" type="image" src="./themes/<?= $g['theme']; ?>/images/icons/icon_x.gif" width="17" height="17" title="delete selected rules" onclick="return confirm('Do you really want to delete the selected rules?')">
+				<input name="del" type="image" src="./themes/<?= $g['theme']; ?>/images/icons/icon_x.gif" width="17" height="17" title="delete selected rules" onclick="return confirm(gettext('Do you really want to delete the selected rules?'))">
 			<?php endif; ?>
 			</td>
                         <td><a href="firewall_nat_edit.php"><img src="/themes/<?= $g['theme']; ?>/images/icons/icon_plus.gif" width="17" height="17" border="0"></a></td>
@@ -352,7 +352,7 @@ echo "<script type=\"text/javascript\" language=\"javascript\" src=\"/javascript
 			</tr>
 		   <tr>
             <td width="14"><img src="./themes/<?= $g['theme']; ?>/images/icons/icon_chain.png" width="11" height="11"></td>
-            <td colspan="3">linked rule</td>
+            <td colspan="3">gettext("linked rule")</td>
           </tr>
     </table>
 	</div>